(***************************************************************************)
(*                                                                         *)
(*     Diese Unit enthlt einen Zeileneditor, der von tInputLine           *)
(*     abgeleitet ist. Er akzeptiert allerdings nur Real-Zahlen            *)
(*     als Eingabe. Aufgerufen wird er mit tRealInputLine.                 *)
(*                                                                         *)
(*     Beachten Sie die Informationen zu tInputLine.                       *)
(*                                                                         *)
(***************************************************************************)

unit RealIn;

{$F+,O+,X+,S-,D-}

interface

uses Objects, Dialogs;

type

  PRealInputLine = ^TRealInputLine;
  TRealInputLine = object(TInputLine)
    function DataSize: Word; virtual;
    procedure GetData(var Rec); virtual;
    procedure SetData(var Rec); virtual;
    function Valid(Command: Word): Boolean; virtual;
  end;

implementation

uses Views, MsgBox;
 
function TRealInputLine.DataSize: Word;
begin
  DataSize := SizeOf(Real);
end;

procedure TRealInputLine.GetData(var Rec);
var
  Code: Integer;
begin
  Val(Data^, Real(Rec), Code);
end;

procedure TRealInputLine.SetData(var Rec);
var
  S: string[16];
begin
  Str(Real(Rec):10, Data^);
  SelectAll(True);
end;

function TRealInputLine.Valid(Command: Word): Boolean;
var
  Code: Integer;
  Value: Real;
  Ok: Boolean;
begin
  Ok := True;
  if (Command <> cmCancel) and (Command <> cmValid) then
  begin
    if Data^ = '' then Data^ := '0';
    Val(Data^, Value, Code);
    if (Code <> 0) then
    begin
      MessageBox('Bitte nur reelle Zahlen eingeben.', nil, mfError + mfOkButton);
      SelectAll(True);
      Ok := False;
    end;
  end;
  if Ok then Valid := TInputLine.Valid(Command)
  else Valid := False;
end;

end.

